//----------------------------------------------------------------------------
// 
//	file: affw_window.h
// 
//	function: afferent 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Fri Oct 23 06:04:50 CDT 1998
// 
//	$Revision: 1.1 $ $Date: 1998/10/26 03:45:33 $
//	$Log: affw_window.h,v $
//	Revision 1.1  1998/10/26 03:45:33  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
#ifndef __AFFW_WINDOW_H
#define __AFFW_WINDOW_H

#include "real.h"
#include "tool_window.h"
#include "matrix_window.h"
#include "netlayer.h"

class affw_window : public tool_window {

protected:

  int	cols, rows;
  int	aff_cols, aff_rows;
  int	sizex, sizey;   // multiplied size
  int	cur_inp;
  REAL  **multi_matrix;	// hold the whole afferent weights thing
  REAL  **buffer_matrix;// hold a single aff w matrix
  netlayer *map;

  matrix_window *matw;

  void init (netlayer *map, int width, int height,
        int aff_cols, int aff_rows, int cur_inp=0);

public:

  affw_window(char *name, netlayer *map, int width, int height, 
	int cur_inp = 0);
  affw_window::affw_window(char *name, netlayer *map, int width, int height,
        int aff_cols, int aff_rows, int cur_inp=0);
  ~affw_window();

  void redraw();
  void set_scale(REAL scale);

};
#endif
