//----------------------------------------------------------------------------
// 
//	file: disputil_window.h
// 
//	function: display utilities for quickly checking 
//		  matrix or weights, etc. 
//		  For use with gdb (and others)
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Wed Sep 23 18:12:54 CDT 1998
// 
//	$Revision: 1.1 $ $Date: 1998/10/05 19:48:46 $
//	$Log: disputil_window.h,v $
//	Revision 1.1  1998/10/05 19:48:46  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
#ifndef __DISPUTIL_WINDOW_H
#define __DISPUTIL_WINDOW_H

#include <window.h>
#include <iostream.h>
#include "util.h"
#include "real.h"
#include "matrix_window.h"
#include "plot_window.h"
#include "tool_window.h"
#include "coord.h"

class disputil_window : public tool_window {

  int   unmapped;
  int   disp_width, disp_height;
  matrix_window *matw;
  plot_window   *plotw;

public:

	// default constructor
        disputil_window(char *name,
                int w, int h, int x, int y);

 	// constructor that directly displays a matrix
        disputil_window(char *name,
                REAL **mat, int cols, int rows, int gran);

	~disputil_window();

  // use toggle() inherited from tool_window to map the window
  void  disp_matrix(REAL **mat, int cols, int rows);

};

#endif
