//----------------------------------------------------------------------------
// 
//	file: colorppmtomat.cc
// 
//	function: save ppm file into a 2d ascii color matrix
//	author:   Subramonia Sarma
//	creation: Mon Feb 18 11:31:46 CST 2002
// 
//	$Revision: $ $Date: $
//	$Log: $
//
//----------------------------------------------------------------------------
#include <iostream.h>
#include <stdio.h>
#include <nnview/ppmio.h>
#include <nnview/matrix.h>
#include <nnview/filename.h>
#include <nnview/real.h>

//----------------------------------------------------------------------------
//	usage() 
//	  - prog usage
//----------------------------------------------------------------------------
void usage(int argc) {

  if (argc < 4) { 
    cout  << " usage: colorppmtomat <cols> <rows> <inputfile> [<rfile> <gfile> <bfile> <hfile> <sfile> <vfile>]" << endl;
    cout  << " 		- uses cartesian coordinate " << endl;
    exit(0);
  }

}

//----------------------------------------------------------------------------
//	draw_bar() 
//	  - fill in given rectangle with a value
//----------------------------------------------------------------------------
void draw_bar(int col, int row, int width, int height,
	REAL value, REAL **dest) {
 

  int start = col*width;
  int start_row = row*height;

  for (int i=start; i<start+width; ++i) 
     for (int j=start_row; j<start_row+height; ++j)
		dest[i][j] = value;

}
  
//----------------------------------------------------------------------------
//	main() 
//	  - the main
//----------------------------------------------------------------------------
int main(int argc, char *argv[]) {

  usage(argc);
	
  FILE *fp;
  FILE *outfiler;
  FILE *outfileg;
  FILE *outfileb;
 
  FILE *outfileh;
  FILE *outfiles;
  FILE *outfilev;


  if (argc==4) {
	  outfiler=fopen("rcolor.dat","w");
	  outfileg=fopen("gcolor.dat","w");
	  outfileb=fopen("bcolor.dat","w");

	  outfileh=fopen("hcolor.dat","w");
	  outfiles=fopen("scolor.dat","w");
	  outfilev=fopen("vcolor.dat","w");
  } else if (argc==10) {
	  outfiler=fopen(argv[4],"w");
	  outfileg=fopen(argv[5],"w");
	  outfileb=fopen(argv[6],"w");

	  outfileh=fopen(argv[7],"w");
	  outfiles=fopen(argv[8],"w");
	  outfilev=fopen(argv[9],"w");
  } else {
	usage(0);
  }

  int cols = atoi(argv[1]);
  int rows = atoi(argv[2]);
  int ppm_width = cols;
  int ppm_height = rows;

  matrix<REAL> *ppm_buffr= new matrix<REAL>(ppm_width,ppm_height);
  matrix<REAL> *ppm_buffg= new matrix<REAL>(ppm_width,ppm_height);
  matrix<REAL> *ppm_buffb= new matrix<REAL>(ppm_width,ppm_height);

  matrix<REAL> *ppm_buffh= new matrix<REAL>(ppm_width,ppm_height);
  matrix<REAL> *ppm_buffs= new matrix<REAL>(ppm_width,ppm_height);
  matrix<REAL> *ppm_buffv= new matrix<REAL>(ppm_width,ppm_height);


  ppmio *io = new ppmio(ppm_buffr->mat,ppm_buffg->mat,ppm_buffb->mat,ppm_width,ppm_height,256);
 
  // read ppm file into matrix
  //io->ppmread(argv[3]);
  io->ppmreadrgb(argv[3]);
  
  //io->ppmwrite("testcolor.ppm");

  ppm_buffr->print_matrix(outfiler);
  ppm_buffg->print_matrix(outfileg);
  ppm_buffb->print_matrix(outfileb);
   
  //ppm_buff->print_matrix();

  char t='t';
 ppmio *iohsv = new ppmio(t,ppm_buffh->mat,ppm_buffs->mat,ppm_buffv->mat,ppm_width,ppm_height,256);
 
  // read ppm file into matrix
  //io->ppmread(argv[3]);
  iohsv->ppmreadhsv(argv[3]);
  //iohsv->ppmwrite("testcolorhsv.ppm");

  ppm_buffh->print_matrix(outfileh);
  ppm_buffs->print_matrix(outfiles);
  ppm_buffv->print_matrix(outfilev);
   
  //ppm_buff->print_matrix();

 

  delete io;
  delete ppm_buffr;
  delete ppm_buffg;
  delete ppm_buffb;
   
  delete iohsv;
  delete ppm_buffh;
  delete ppm_buffs;
  delete ppm_buffv;
   
  fclose(outfiler);
  fclose(outfileg);
  fclose(outfileb);
  fclose(outfileh);
  fclose(outfiles);
  fclose(outfilev);

}

